import algds.contest.Hamster;
import java.util.*;

/**
 * Referenzhamster 2001: Toto.
 * Dieser Hamster liefert die Punkte, die ueberboten werden muessen.
 * @author Kai-Uwe Sattler, Stephan Finn
 */

public class Toto extends Hamster 
{
	boolean finished = false;

	/**
	 * Hauptmethode.
	 * Geht sammeln, wenn nichts aussergewoehnliches passier ist,
	 * kehrt er nach Hause zurueck und legt alles Mais ab,
	 * bis er irgendwann mal einen Rundweg gefunden hat; Also
	 * auf dem Hinweg ueber das Heimatfeld kommt.
	 */
	public void run () 
	{
	finished = false;
	Vector inst = null;
	while(!finished)
	{
	    inst = goShopping();
	    if (inst!=null)
	    {
		goHome (inst);
		dropAll();
	    }
	}
	}

	/**
	 * Legt alles ab, was er an Mais haben kann.
	 */
	private void dropAll()
	{
	int dropped = 0;
	for (int i=1; i<=CORNSIZE_MAX; i++)
	    dropped += drop(i, CORNCARRY_MAX)*i;
	debuglog(dropped+" corn dropped.\n");
	}

	/**
	 * Welche Richtung ergibt sich, wenn ich mich n mal nach links
	 * drehe? (Damit man nicht immer so viele Faelle unterscheiden 
	 * muss
	 */
	public int addDir(int dir, int summand)
	{
	int dummy = dir + summand;
	if (dummy > 3)
	    dummy = dummy-4;
	return dummy;
	}

	/**
	 * Soll dem Hamster die Richtung zurueck geben, die der 
	 * entgegengesetzten entspricht. Dir 34 soll dabei dem
	 * Beamer etsprechen.
	 */
	private int negDir(int dir)
	{
	int res = 34;
	if (dir != 34)
	    res = DIR_WEST+addDir(dir-DIR_WEST,2);
	return res;
	}


	/**
	 * Geht Mais sammeln bis das Maul voll ist.
	 */
	private Vector goShopping()
	{
	boolean full = false;
	boolean lastLoopBeamed = false;
	boolean thereIsCorn = false;
	int lastDirection = 0;
	int circleCounter = 0;

	// hiermit merkt er sich, wo er lang gelaufen ist!
	Vector inst = null;

	while (!full) 
	{
	    /**
	     * Damit der Hamster auch recht gut wieder nach
	     * Hause findet bekommt er, wenn er ueber sein 
	     * Heimatfeld geht ein neues Gedaechtnis!
	     * Und zu einem neuen Gedaechtnis gehoert natuerlich auch,
	     * das er vergisst, das dort irgendwo noch Korn war!
	     */
	    if (atHome())
	    {
		inst = new Vector();
		thereIsCorn = false;
	    }

	    if ((lookCurrent()&BEAMER)==BEAMER && !lastLoopBeamed)
	    {
		/**
		 * Der Hamster hier ist ziemlich neugierig und
		 * laesst sich mit vorliebe irgend wohin beamen.
		 * Ist also ein Beamer auf dem Weg und hat er sich 
		 * nicht gerade im letzten Durchlauf beamen lassen,
		 * wird dieser erst mal benutzt.
		 */
		beamMeUp();
		lastLoopBeamed = true;
		circleCounter = 0;
		lastDirection = 34;
	    }
	    else if ((look () & WALL) != WALL && circleCounter < 3)
	    {
		/**
		 * Wenn kein Beamer da war und keine Wand in Sicht,
		 * schaut er, ob links neben ihm eine Wand ist, an der
		 * er sich orientieren kann. 
		 */
		if (lastLoopBeamed)
		    circleCounter=0;
		turn(TURN_LEFT);
		if ((look () & WALL) == WALL)
		{
		    turn(TURN_RIGHT);
		    circleCounter=0;
		}
		else
		    circleCounter++;
		forward ();

		/**
		 * Sollte dies nicht der Fall sein, geht er erst mal einen
		 * Schritt in diese Richtung. "circleCounter" dient dazu,
		 * festzustellen, ob er im Freien steht (4'er Block).
		 * Ist dies der Fall, muss er so lange gerade aus laufen,
		 * bis er eine Wand findet, an der er sich orientieren kann.
		 */
		if (circleCounter == 4)
		{
		    /**
		     * Hier ist er 4 Mal in Folge links herum gegangen, 
		     * steht also im Freien und auf einem Feld, auf dem
		     * er schon mal war. Damit er auf dem Rueckweg nicht
		     * wieder diese "Runde" laeuft, werden die letzten 4
		     * Eintraege aus "inst" geloescht!
		     */
		    for (int i = 0; i<4; i++)
			inst.removeElement(inst.lastElement());
		    if (inst == null)
			inst = new Vector();
		}
		lastLoopBeamed = false;
		lastDirection = getDirection();
	    }
	    else if ((look()&WALL) != WALL)
	    {
		/**
		 * In diese Abfrage gelangt er nur, wenn er links
		 * neben sich keine Wand mehr hat. Er muss also so 
		 * lange gerade aus laufen, bis er wieder eine Wand findet.
		 */ 
		forward();
		lastLoopBeamed = false;
		lastDirection = getDirection();
	    }
	    else
	    {
		/** 
		 * An sonsten nach Links und recht schauen, ob dort Waende
		 * sind. Und es wird die erste Richtung genommen, die gefunden
		 * wird. Sind links und rechts Waende, muss man wohl oder 
		 * uebel zuzueck gehen.
		 */
		int counter = 1; // Wand voraus!
		turn(TURN_LEFT);
		if((look()&WALL) == WALL)
		{
		    counter++; // Wand links!
		    turn(TURN_RIGHT); turn(TURN_RIGHT);
		    if((look()&WALL) == WALL)
		    {
			counter++; // Wand rechts!
			turn(TURN_RIGHT);
			if ((look()&WALL) == WALL)
			    counter++; // Wand hinten!
		    }
		}
	    
		/** 
		 * Sollte "counter" gleich 4 sein, sind offensichtlich 
		 * rundum Waende und er muss entscheiden, was
		 * er dann macht. Sollte er auf einem Beamer stehen will 
		 * er einfach nur noch nach Hause! Solche Gemeinheiten 
		 * verkraftet er nicht!! 
		 */
		if (counter == 4)
		{
		    if ((lookCurrent()&BEAMER)==BEAMER && !atHome())
			return inst;
		    else
		    {
			finished = true;
			log("So ne fiesen Dinger muss man sich hier bieten");
			log("lassen! Wird man einfach schon auf dem Heimatfeld");
			log("eingesperrt!! Echt eine masslose Sauerei!");
			return null;
		    }
		}
		else
		    forward ();
		lastLoopBeamed = false;
		circleCounter = 0;
		lastDirection = getDirection();
	    }
	
	    /** 
	     * Kommt er ueber das Heimatfeld, ist nicht im 4-er Kreis
	     * gelaufen und hat auch kein Korn in der Zwischenzeit gefunden,
	     * hat er einfach keine Lust mehr und hoert ganz auf. 
	     * Wenn man im Kreis laeuft muss man sich ja immerhin gedanken
	     * machen, wie man da wieder heraus kommt. Das ist ihm etwas
	     * zu kompliziert.
	     * Kommt er jedoch sonst mal ueber das Heimatfeld (sieht also
	     * noch Erfolgschancen) legt er erst mal alles ab, was er so
	     * bei sich hat.
	     */
	    if (atHome () && circleCounter < 4 && !thereIsCorn)
	    {
		finished = true;
		log("Walked once around.\n");
		dropAll();
		return null;
	    }
	    else if (atHome())
		dropAll();

	    if (!atHome())
	    {
		/** 
		 * Hier ist er wieder mal etwas duemmlich und versucht
		 * einfach auf jedem Feld im Labyrinth alle Korn-Groessen
		 * aufzunehmen. Er hat vorher nicht geschaut, ob ueberhaupt 
		 * Korn da ist. Er faengt mit den groessten
		 * Koernern an und hoert bei den kleinsten wieder auf.
		 * Selbst, wenn er schon laengst gar nichts mehr tragen kann!
		 */
		for(int i=CORNSIZE_MAX; i>0; i--)
		    take (i, CORNCARRY_MAX);
		
		/**
		 * Und er versucht sich mal zu merken, ob im Labyrinth noch
		 * Korn ligt. Ob er es wieder findet ist eine andere Geschichte!
		 */ 
		if (getAvailableCorn()[0]>0)
		    thereIsCorn = true;
	    }

	    /** 
	     * Wenn seine Energie unter 3000 gefallen ist, versucht
	     * er, so dumm wie er ist, einfach mal von jeder Korn-Groesse
	     * so viele zu essen, dass er wieder ueber 3000 EP kommt.
	     * Auch wenn er keine Koerner im Maul hat!! Hat er pech,
	     * verhungert er irgend wann und kassiert Strafpunkte.
	     */
	    int gr = CORNSIZE_MAX;
	    while (getEnergy()<3000 && gr>0)
	    {
		int need = ((3000-getEnergy())/(ENERGY_CORN/gr))+1;
		eat(gr, need);
		gr--;
	    }

	    /** 
	     * Hier schaut er dann mal nach, wie viel er denn nun
	     * schon aufgesammelt hat. Kann er nichts mehr tragen,
	     * bricht er hier ab und versucht mit einer anderen
	     * Funktion nach Hause zu kommen.
	     * Man sollte hier vorsichtig sein, gibt es im Labyrinth
	     * z.B. nur Koerner der Groesse 7 wird er nie das Maul
	     * voll kriegen. Fuehrt ihn sein Weg nun nicht wieder
	     * ueber das Heimatfeld (die andere Abbruchbedingung weiter oben),
	     * wird er wohl oder uebel klaeglich verhungern.
	     */
	    if (getCarriedCorn(0) == CORNCARRY_MAX) 
	    {
		full = true;
		debuglog ("go home...\n");
	    }

	    /** 
	     * Jetzt muss er sich nur noch merken, wo er her gekommen ist.
	     * dazu speichert er einfach die entgegengesetzte Richtung
	     * im "Vector" ab.
	     */
	    inst.add(new Integer(negDir(lastDirection)));

	    /**
	     * Und damit er , wenn er sehr weit von zu Hause weg ist
	     * auch noch nach Hause kommt ohne zu verhungern und ohne
	     * mitten in der Weite der Labyrinthes stehen bleiben zu muessen,
	     * prueft er hier noch, ob er mit der Energie die er hat
	     * noch nach Hause kommt.
	     */
	    if (getEnergy()-(inst.capacity()*Math.abs(ENERGY_STEP+ENERGY_TURN))< ENERGY_CORN) 
	    {
		/**
		 * 'ENERGY_CORN' stellt dabei seine Notreserve dar.
		 */
		finished = true;
		return inst;
	    }
	}
	return inst;
	}

	/**
	 * Geht auf dem gleichen Weg nach Hause wie er gekommen ist.
	 */
	private void goHome (Vector inst) 
	{
	Object[] o = inst.toArray();
	int dir = 0;
	for (int i = o.length-1; i>=0; i--)
	{
	    dir = ((Integer)o[i]).intValue();
	    if (dir == 34)
		beamMeUp();
	    else
	    {
		while(dir != getDirection())
		    turn(TURN_LEFT);
		forward();
	    }
	}
	turn(TURN_RIGHT); turn(TURN_RIGHT);
	}
}